<template>
  <div class="col my-3 d-flex justify-content-center align-items-center">
    <div class="card p-3">
      <div
        class="card-content d-flex h-100 flex-column justify-content-between align-items-center"
      >
        <div class="d-flex image justify-content-center">
          <img v-if="product.image" :src="product.image" :alt="product.title" />
          <IconProduct v-else />
        </div>
        <div class="d-flex infos align-items-center">
          <div class="">
            <div class="main-heading mt-0" @click="goToProduct">
              {{ product.title }}
            </div>
            <div class="d-flex flex-row user-ratings align-items-center">
              <div class="ratings">
                <i
                  class="star"
                  v-for="i in Math.round(parseFloat(product.rating?.rate))"
                  :key="i"
                ></i>
                <i
                  class="star grey"
                  v-for="i in 5 - Math.round(parseFloat(product.rating?.rate))"
                  :key="i"
                ></i>
              </div>
              <h6 class="text-muted ml-1">{{ product.rating?.rate }}</h6>
            </div>
          </div>
        </div>
        <button @click="addToCart(product)" class="btn btn-danger w-100">
          Add to cart
        </button>
      </div>
    </div>
  </div>
</template>

<script setup>
import IconProduct from '@/components/IconProduct.vue'
import { computed } from 'vue'
import { useCartStore } from '@/stores/cart'
import router from '@/router'

const props = defineProps({
  product: {
    type: Object,
    required: true
  }
})
const goToProduct = () => {
  router.push(`/product/${product.value.id}`)
}
const cartStore = useCartStore()
const { addToCart } = cartStore
const product = computed(() => props.product)
</script>

<style lang="scss" scoped>
.card {
  width: 350px;
  height: 370px;
  .card-content {
    .image {
      width: 100%;
      height: 50%;
    }
    .infos {
      height: 50%;
      .main-heading {
        font-size: 1em;
        color: rgb(208, 47, 47);
        cursor: pointer;
        &:hover {
          color: rgb(133, 30, 30);
        }
      }
    }
  }
}

.star {
  position: relative;

  display: inline-block;
  width: 0;
  height: 0;

  margin-left: 0.9em;
  margin-right: 0.9em;
  margin-bottom: 1.2em;

  border-right: 0.3em solid transparent;
  border-bottom: 0.7em solid #fc0;
  border-left: 0.3em solid transparent;

  /* Controlls the size of the stars. */
  font-size: 24px;

  &:before,
  &:after {
    content: '';

    display: block;
    width: 0;
    height: 0;

    position: absolute;
    top: 0.6em;
    left: -1em;

    border-right: 1em solid transparent;
    border-bottom: 0.7em solid #fc0;
    border-left: 1em solid transparent;

    transform: rotate(-35deg);
  }

  &:after {
    transform: rotate(35deg);
  }
  &.grey {
    border-bottom: 0.7em solid #959595;
    &:before,
    &:after {
      border-bottom: 0.7em solid #959595;
    }
  }
}
</style>
